## connectome-workbench 1.3.2.1+rb2

=== src/CMakeLists.txt ===
#
# Minimum required version of CMAKE
#
CMAKE_MINIMUM_REQUIRED (VERSION 2.8)

#
# Set to true for verbose output when debugging this file
#
SET(WB_CMAKE_VERBOSE_OUTPUT_FLAG TRUE)

##########################################################################################
#
# A function to get all user defined variables with a specified prefix
# From https://cmake.org/Wiki/CMake/Tutorials/SettingVariableGroups
#
function (getListOfVarsStartingWith _prefix _varResult)
    get_cmake_property(_vars CACHE_VARIABLES)
    string (REGEX MATCHALL "(^|;)${_prefix}[A-Za-z0-9_]*" _matchedVars "${_vars}")
    set (${_varResult} ${_matchedVars} PARENT_SCOPE)
endfunction()


##########################################################################################
#
# Workbench CACHE variables
# TSC: use "CACHE <type> <docstring>" syntax in SET commands so they can be overridden by cmake options
#
set (WORKBENCH_QT5_DISABLE_DEPRECATED FALSE CACHE BOOL 
     "If TRUE, use of Qt 5 deprecated functionality will cause compiler to fail")
set (WORKBENCH_USE_CMAKE_AUTOMOC FALSE CACHE BOOL 
     "If TRUE, use CMAKE_AUTOMOC command for generating 'moc' files")
set (WORKBENCH_USE_QT5 TRUE CACHE BOOL 
     "If TRUE, require Qt5, else Qt4.<NEWLINE>Specify as argument to cmake: -DWORKBENCH_USE_QT5=TRUE")
set (WORKBENCH_USE_QT5_QOPENGL_WIDGET FALSE CACHE BOOL 
     "With Qt5, QOpenGLWidget instead of deprecated QGLWidget")
set (WORKBENCH_MESA_DIR "" CACHE PATH 
     "Directory containing Mesa's 'include' and 'lib' <NEWLINE>directories.  Mesa is optional and used by <NEWLINE>wb_command's -show-scene operation.")

##########################################################################################
#
# Setting the compiler MUST be done before the PROJECT
# statement or else an infinite loop will occur indicating
# that the compiler has been redefined.
#
IF(APPLE)
    ADD_DEFINITIONS(-DCARET_OS_MACOSX)
ELSEIF(UNIX)
    IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
        ADD_DEFINITIONS(-DCARET_OS_LINUX)
        SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
    ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
ELSEIF(WIN32)
    ADD_DEFINITIONS(-DCARET_OS_WINDOWS)
    # Policy CMP0020 is related to Qt
    # https://cmake.org/cmake/help/v3.5/policy/CMP0020.html
    if(POLICY CMP0020) 
        cmake_policy(SET CMP0020 NEW)
    endif()
    IF(MSVC)
        ADD_DEFINITIONS(-DCARET_OS_WINDOWS_MSVC)
            ADD_DEFINITIONS(-D_USE_MATH_DEFINES -DNOMINMAX)
            SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -MP -wd4290 -wd4244 -wd4267 -wd4305 -wd4100 -wd4005" )
        IF(CMAKE_CL_64)
        ELSE()
        ENDIF(CMAKE_CL_64)
    ELSE(MSVC)
    ENDIF(MSVC)
ELSE(APPLE)
    MESSAGE(SEND_ERROR "Unrecognized operating system " ${CMAKE_SYSTEM_NAME})
ENDIF(APPLE)

#
# Intel compiler
#
IF (${CMAKE_CXX_COMPILER} MATCHES "^.*icpc$")
    ADD_DEFINITIONS("-W -Wall -Werror=return-type -Werror=switch -Wunused-parameter")
ENDIF (${CMAKE_CXX_COMPILER} MATCHES "^.*icpc$")

#
# Clang compiler on Mac
#
UNSET(CLANG_FLAG)
IF (${CMAKE_CXX_COMPILER} MATCHES "^.*clang\\+\\+.*")
    SET(CLANG_FLAG TRUE)
ENDIF (${CMAKE_CXX_COMPILER} MATCHES "^.*clang\\+\\+.*")
IF (${CMAKE_CXX_COMPILER} MATCHES "^.*clang2\\+\\+.*")
    SET(CLANG_FLAG TRUE)
ENDIF (${CMAKE_CXX_COMPILER} MATCHES "^.*clang2\\+\\+.*")
IF (CLANG_FLAG)
    ADD_DEFINITIONS("-W -Wall -Werror=return-type -Werror=switch -Wunused-parameter -Wno-deprecated-declarations")
ENDIF (CLANG_FLAG)


#
# IF GNU compiler, functions without a return type or switch
# statements that do not handle all of the enumerated types
# are treated as an error.  Also, all warnings.
#
IF (NOT MSVC)
    if (CMAKE_COMPILER_IS_GNUCC)
        execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                        OUTPUT_VARIABLE GCC_VERSION)
        message("gcc version is: " ${GCC_VERSION})
        if(${GCC_VERSION} VERSION_LESS "4.2")
            ADD_DEFINITIONS(-W -Wall)
        else()
            ADD_DEFINITIONS(-W -Wall -Werror=return-type -Werror=switch -Wunused-parameter)
        endif()

        if (${GCC_VERSION} VERSION_LESS "4.9")
            # there is no greater than or equal in CMake
        else()
            ADD_DEFINITIONS(-Wno-narrowing -Wno-unused-local-typedefs)
        endif()
    endif()
ENDIF (NOT MSVC)

##########################################################################################
#
# If GNU compiler, use SIMD-based dot computation, if possible
#
SET(SIMD_RESULT "Search for SIMD disabled for compiler on this system.")
if ((CMAKE_COMPILER_IS_GNUCC OR CLANG_FLAG) AND CMAKE_SIZEOF_VOID_P EQUAL 8)
    #
    # Define flag to avoid trying to compile SIMD stuff (coded for x86_64 only)
    #
    SET(WORKBENCH_USE_SIMD TRUE CACHE BOOL "try to compile with SIMD support")

    #
    # If we should try to use SIMD, check whether cpuinfo compiles
    #
    IF (WORKBENCH_USE_SIMD)
        TRY_COMPILE(CPUINFO_COMPILES ${CMAKE_CURRENT_BINARY_DIR}/cpuinfo_compile_test ${CMAKE_CURRENT_SOURCE_DIR}/kloewe/cpuinfo cpuinfo)
        
        #
        # Add the necessary definition and include directory to enable the 
        # SIMD-based dot product implementations
        #
        IF (CPUINFO_COMPILES)
            ADD_DEFINITIONS(-DCARET_DOTFCN)
            INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/kloewe/dot/src)
            SET(SIMD_RESULT "Enabled")
        ELSE()
            SET(SIMD_RESULT "Failed when compiling with SIMD")
        ENDIF()
    ELSE (WORKBENCH_USE_SIMD)
        SET(SIMD_RESULT "Search for SIMD disabled, WORKBENCH_USE_SIMD=FALSE")
    ENDIF (WORKBENCH_USE_SIMD)
endif ((CMAKE_COMPILER_IS_GNUCC OR CLANG_FLAG) AND CMAKE_SIZEOF_VOID_P EQUAL 8)

#TSC: we require c++11, so it needs to be in the compile flags - in older cmake, this needs to be done manually
IF (${CMAKE_VERSION} VERSION_LESS "3.1")
    IF (CMAKE_COMPILER_IS_GNUCC)
        include(CheckCXXCompilerFlag)
        CHECK_CXX_COMPILER_FLAG("-std=c++11" GCC_STD11)
        IF (${GCC_STD11})
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
        ELSE (${GCC_STD11})
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
        ENDIF (${GCC_STD11})
    ENDIF (CMAKE_COMPILER_IS_GNUCC)
ELSE (${CMAKE_VERSION} VERSION_LESS "3.1")
    SET(CMAKE_CXX_STANDARD 11)
    SET(CMAKE_CXX_STANDARD_REQUIRED TRUE)
ENDIF (${CMAKE_VERSION} VERSION_LESS "3.1")

##########################################################################################
#
# OpenSSL
#
SET(OPENSSL_RESULT "Not Found")
FIND_PACKAGE(OpenSSL)
IF(OPENSSL_FOUND)
    INCLUDE_DIRECTORIES(${OPENSSL_INCLUDE_DIR})
    SET(OPENSSL_RESULT "${OPENSSL_VERSION}   ${OPENSSL_LIBRARIES}")
ELSE (OPENSSL_FOUND)
    MESSAGE("OpenSSL NOT FOUND.  May need to define OPENSSL_ROOT_DIR when running CMake.")
    MESSAGE("   cmake -DOPENSSL_ROOT_DIR=<path> \n")
    MESSAGE("See: https://cmake.org/cmake/help/v3.5/module/FindOpenSSL.html")
ENDIF(OPENSSL_FOUND)

##########################################################################################
#
# Must have QT 4.8 or QT 5, recommended 5.6 or later
# https://cmake.org/cmake/help/v3.5/manual/cmake-packages.7.html#manual:cmake-packages(7)
# Modules List: http://doc.qt.io/qt-5/qtmodules.html
#
SET(QT_RESULT "Not Found")
SET(CARET_QT5_LINK "")
IF (WORKBENCH_USE_QT5) 
    #
    # The OpenGL module is deprecated in Qt5 and 
    # is needed only if QGLWidget is used for
    # the OpenGL graphics.
    #
    IF (NOT WORKBENCH_USE_QT5_QOPENGL_WIDGET)
        SET(WB_QT_OPENGL_MODULE "OpenGL")
    ENDIF ()

    FIND_PACKAGE(Qt5 REQUIRED COMPONENTS Concurrent Core Gui Network ${WB_QT_OPENGL_MODULE} PrintSupport Test Widgets Xml)
    IF (WORKBENCH_USE_QT5_QOPENGL_WIDGET)
        #
        # QGLWidget is deprecated in Qt 5 and is replaced with QOpenGLWidget
        #
        # If WORKBENCH_USE_QT5_QOPENGL_WIDGET is defined, QOpenGLWidget is used
        # for OpenGL.  Otherwise, QGLWidget is used.
        #
        add_definitions(-DWORKBENCH_USE_QT5_QOPENGL_WIDGET)
    ELSE (WORKBENCH_USE_QT5_QOPENGL_WIDGET)
        remove_definitions(-DWORKBENCH_USE_QT5_QOPENGL_WIDGET)
    ENDIF (WORKBENCH_USE_QT5_QOPENGL_WIDGET)

    IF (WORKBENCH_QT5_DISABLE_DEPRECATED)
        # Causes Qt to remove declarations for deprecated functionality
        add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050700) 
        # Enable usage of replacements for Qt deprecated functionality in Workbench source code
        add_definitions(-DWORKBENCH_REPLACE_QT_DEPRECATED)
    ENDIF (WORKBENCH_QT5_DISABLE_DEPRECATED)

    #small hack to get the qt5 compile flag requirements into libraries
    SET(CARET_QT5_LINK "Qt5::Core")

    SET(QT_RESULT "${Qt5_VERSION}")
ELSE ()
    FIND_PACKAGE(Qt4 4.8 REQUIRED)
    IF(QT4_FOUND)
        INCLUDE(${QT_USE_FILE})
        SET(QT_RESULT "${QTVERSION}")
    ELSE(QT4_FOUND)
        MESSAGE(SEND_ERROR "QT4 not found")
    ENDIF(QT4_FOUND)
ENDIF ()

##########################################################################################
#
# Try to find Qwt, otherwise use bundle
#
SET(QWT_RESULT "Not Found")
IF (NOT WIN32)
    PKG_CHECK_MODULES(Qwt qwt)
ENDIF (NOT WIN32)
IF (Qwt_FOUND)
    SET(QWT_RESULT "Using Qwt Library ${Qwt_LIBRARIES}")
ELSE (Qwt_FOUND)
    SET(QWT_RESULT "In Workbench Source Code")
ENDIF (Qwt_FOUND)

##########################################################################################
#
# Need OpenGL
#
SET(OPENGL_RESULT "")
FIND_PACKAGE(OpenGL REQUIRED)
IF (OPENGL_FOUND)
    #
    # Need help finding includes on Apple
    #
    IF (APPLE)
        # When searching for the include directory, find the location
        # for the OpenGL framework rather than an individual header file.
        FIND_PATH(OPENGL_INCLUDE_DIR OpenGL.framework
                  /System/Library/Frameworks
                  /Library/Frameworks
                  ~/Library/Frameworks)
    ENDIF (APPLE)
    #
    # OpenGL Include Directory
    #
    INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
    MESSAGE("OpenGL Include Directory: ${OPENGL_INCLUDE_DIR}")
    MESSAGE("OpenGL Libraries: ${OPENGL_LIBRARIES}")
    SET(OPENGL_RESULT ${OPENGL_LIBRARIES})
ELSE (OPENGL_FOUND)
    MESSAGE(SEND_ERROR "OpenGL Libraries were not found")
ENDIF (OPENGL_FOUND)

##########################################################################################
#
# Look for GLEW but only on Windows
#
SET(GLEW_RESULT "No")
IF (WIN32)
    FIND_PACKAGE(GLEW)
ENDIF ()

IF (GLEW_FOUND)
    SET(GLEW_RESULT "${GLEW_INCLUDE_DIRS} ${GLEW_LIBRARIES}")
    MESSAGE("GLEW Include Dirs: ${GLEW_INCLUDE_DIRS}")
    MESSAGE("GLEW Libraries: ${GLEW_LIBRARIES}")
    STRING(FIND ${GLEW_LIBRARIES} "glew32s.lib" GLEW_STATIC_LIB_NAME_INDEX)
    ADD_DEFINITIONS(-DHAVE_GLEW)
    IF (GLEW_STATIC_LIB_NAME_INDEX GREATER -1)
        ADD_DEFINITIONS(-DHAVE_GLEW_STATIC_LIB)
        MESSAGE("GLEW Static Library Found")
    ENDIF()
    INCLUDE_DIRECTORIES(${GLEW_INCLUDE_DIRS})
ELSE()
    SET(GLEW_LIBRARIES "")
    SET(GLEW_INCLUDE_DIRS "")
    IF (WIN32)
        MESSAGE(SEND_ERROR "GLEW not found and is required on Windows for finding OpenGL functions.\n"
                           "    Setting CMAKE_PREFIX_PATH to the GLEW installation directory when\n"
                           "    running CMAKE may help find GLEW.\n")
    ENDIF()
ENDIF()

##########################################################################################
#
# The Find OpenMP package may not work on all systems and the user may
# furnish the paths to the OpenMP files by using environment variables.
#
# The environment variables are:
#    OPENMP_COMPILE_OPTION=-fopenmp
#    OPENMP_HEADER_DIR=/usr/local/clang-openmp-opt/llvm/build/Release/include
#    OPENMP_LIB_DIR=/usr/local/clang-openmp-opt/llvm/build/Release/lib
#
UNSET(OPENMP_FOUND)
IF (EXISTS $ENV{OPENMP_HEADER_DIR})
    MESSAGE("OpenMP Header File:  $ENV{OPENMP_HEADER_DIR}")
    IF (EXISTS $ENV{OPENMP_LIB_DIR})
        MESSAGE("OpenMP Library File: $ENV{OPENMP_LIB_DIR}")
        SET (STUFF $ENV{OPENMP_COMPILE_OPTION})
        IF (DEFINED STUFF)

=== src/Algorithms/CMakeLists.txt ===
#
# Name of project
#
PROJECT (Algorithms)

#
# Need XML from Qt
#
SET(QT_DONT_USE_QTGUI)

#
# Add QT for includes
#
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
endif()
IF (QT4_FOUND)
    INCLUDE(${QT_USE_FILE})
ENDIF ()

#
# Create the helper library
#
ADD_LIBRARY(Algorithms
AbstractAlgorithm.h
AlgorithmBorderResample.h
AlgorithmBorderToVertices.h
AlgorithmCiftiAllLabelsToROIs.h
AlgorithmCiftiAverage.h
AlgorithmCiftiAverageDenseROI.h
AlgorithmCiftiAverageROICorrelation.h
AlgorithmCiftiCorrelation.h
AlgorithmCiftiCorrelationGradient.h
AlgorithmCiftiCreateDenseScalar.h
AlgorithmCiftiCreateDenseTimeseries.h
AlgorithmCiftiCreateLabel.h
AlgorithmCiftiCrossCorrelation.h
AlgorithmCiftiDilate.h
AlgorithmCiftiErode.h
AlgorithmCiftiExtrema.h
AlgorithmCiftiFalseCorrelation.h
AlgorithmCiftiFindClusters.h
AlgorithmCiftiGradient.h
AlgorithmCiftiLabelAdjacency.h
AlgorithmCiftiLabelProbability.h
AlgorithmCiftiLabelToBorder.h
AlgorithmCiftiLabelToROI.h
AlgorithmCiftiMergeDense.h
AlgorithmCiftiMergeParcels.h
AlgorithmCiftiPairwiseCorrelation.h
AlgorithmCiftiParcellate.h
AlgorithmCiftiParcelMappingToLabel.h
AlgorithmCiftiReduce.h
AlgorithmCiftiReorder.h
AlgorithmCiftiReplaceStructure.h
AlgorithmCiftiResample.h
AlgorithmCiftiRestrictDenseMap.h
AlgorithmCiftiROIsFromExtrema.h
AlgorithmCiftiSeparate.h
AlgorithmCiftiSmoothing.h
AlgorithmCiftiTranspose.h
AlgorithmCiftiVectorOperation.h
AlgorithmCreateSignedDistanceVolume.h
AlgorithmException.h
AlgorithmFiberDotProducts.h
AlgorithmFociResample.h
AlgorithmGiftiAllLabelsToROIs.h
AlgorithmGiftiLabelAddPrefix.h
AlgorithmGiftiLabelToROI.h
AlgorithmLabelDilate.h
AlgorithmLabelErode.h
AlgorithmLabelModifyKeys.h
AlgorithmLabelProbability.h
AlgorithmLabelResample.h
AlgorithmLabelToBorder.h
AlgorithmLabelToVolumeMapping.h
AlgorithmMetricDilate.h
AlgorithmMetricErode.h
AlgorithmMetricEstimateFWHM.h
AlgorithmMetricExtrema.h
AlgorithmMetricFalseCorrelation.h
AlgorithmMetricFillHoles.h
AlgorithmMetricFindClusters.h
AlgorithmMetricGradient.h
AlgorithmMetricReduce.h
AlgorithmMetricRegression.h
AlgorithmMetricRemoveIslands.h
AlgorithmMetricResample.h
AlgorithmMetricROIsFromExtrema.h
AlgorithmMetricROIsToBorder.h
AlgorithmMetricSmoothing.h
AlgorithmMetricTFCE.h
AlgorithmMetricToVolumeMapping.h
AlgorithmMetricVectorOperation.h
AlgorithmMetricVectorTowardROI.h
AlgorithmNodesInsideBorder.h
AlgorithmSignedDistanceToSurface.h
AlgorithmSurfaceAffineRegression.h
AlgorithmSurfaceApplyAffine.h
AlgorithmSurfaceApplyWarpfield.h
AlgorithmSurfaceAverage.h
AlgorithmSurfaceCortexLayer.h
AlgorithmSurfaceCreateSphere.h
AlgorithmSurfaceCurvature.h
AlgorithmSurfaceDistortion.h
AlgorithmSurfaceFlipLR.h
AlgorithmSurfaceGenerateInflated.h
AlgorithmSurfaceInflation.h
AlgorithmSurfaceMatch.h
AlgorithmSurfaceModifySphere.h
AlgorithmSurfaceResample.h
AlgorithmSurfaceSmoothing.h
AlgorithmSurfaceSphereProjectUnproject.h
AlgorithmSurfaceToSurface3dDistance.h
AlgorithmSurfaceWedgeVolume.h
AlgorithmVolumeAffineResample.h
AlgorithmVolumeAllLabelsToROIs.h
AlgorithmVolumeDilate.h
AlgorithmVolumeDistortion.h
AlgorithmVolumeErode.h
AlgorithmVolumeEstimateFWHM.h
AlgorithmVolumeExtrema.h
AlgorithmVolumeFillHoles.h
AlgorithmVolumeFindClusters.h
AlgorithmVolumeGradient.h
AlgorithmVolumeLabelProbability.h
AlgorithmVolumeLabelToROI.h
AlgorithmVolumeLabelToSurfaceMapping.h
AlgorithmVolumeParcelResampling.h
AlgorithmVolumeParcelResamplingGeneric.h
AlgorithmVolumeParcelSmoothing.h
AlgorithmVolumeReduce.h
AlgorithmVolumeRemoveIslands.h
AlgorithmVolumeROIsFromExtrema.h
AlgorithmVolumeSmoothing.h
AlgorithmVolumeTFCE.h
AlgorithmVolumeToSurfaceMapping.h
AlgorithmVolumeVectorOperation.h
AlgorithmVolumeWarpfieldAffineRegression.h
AlgorithmVolumeWarpfieldResample.h
OverlapLogicEnum.h

AbstractAlgorithm.cxx
AlgorithmBorderResample.cxx
AlgorithmBorderToVertices.cxx
AlgorithmCiftiAllLabelsToROIs.cxx
AlgorithmCiftiAverage.cxx
AlgorithmCiftiAverageDenseROI.cxx
AlgorithmCiftiAverageROICorrelation.cxx
AlgorithmCiftiCorrelation.cxx
AlgorithmCiftiCorrelationGradient.cxx
AlgorithmCiftiCreateDenseScalar.cxx
AlgorithmCiftiCreateDenseTimeseries.cxx
AlgorithmCiftiCreateLabel.cxx
AlgorithmCiftiCrossCorrelation.cxx
AlgorithmCiftiDilate.cxx
AlgorithmCiftiErode.cxx
AlgorithmCiftiExtrema.cxx
AlgorithmCiftiFalseCorrelation.cxx
AlgorithmCiftiFindClusters.cxx
AlgorithmCiftiGradient.cxx
AlgorithmCiftiLabelAdjacency.cxx
AlgorithmCiftiLabelProbability.cxx
AlgorithmCiftiLabelToBorder.cxx
AlgorithmCiftiLabelToROI.cxx
AlgorithmCiftiMergeDense.cxx
AlgorithmCiftiMergeParcels.cxx
AlgorithmCiftiPairwiseCorrelation.cxx
AlgorithmCiftiParcellate.cxx
AlgorithmCiftiParcelMappingToLabel.cxx
AlgorithmCiftiReduce.cxx
AlgorithmCiftiReorder.cxx
AlgorithmCiftiReplaceStructure.cxx
AlgorithmCiftiResample.cxx
AlgorithmCiftiRestrictDenseMap.cxx
AlgorithmCiftiROIsFromExtrema.cxx
AlgorithmCiftiSeparate.cxx
AlgorithmCiftiSmoothing.cxx
AlgorithmCiftiTranspose.cxx
AlgorithmCiftiVectorOperation.cxx
AlgorithmCreateSignedDistanceVolume.cxx
AlgorithmException.cxx
AlgorithmFiberDotProducts.cxx
AlgorithmFociResample.cxx
AlgorithmGiftiAllLabelsToROIs.cxx
AlgorithmGiftiLabelAddPrefix.cxx
AlgorithmGiftiLabelToROI.cxx
AlgorithmLabelDilate.cxx
AlgorithmLabelErode.cxx
AlgorithmLabelModifyKeys.cxx
AlgorithmLabelProbability.cxx
AlgorithmLabelResample.cxx
AlgorithmLabelToBorder.cxx
AlgorithmLabelToVolumeMapping.cxx
AlgorithmMetricDilate.cxx
AlgorithmMetricErode.cxx
AlgorithmMetricEstimateFWHM.cxx
AlgorithmMetricExtrema.cxx
AlgorithmMetricFalseCorrelation.cxx
AlgorithmMetricFillHoles.cxx
AlgorithmMetricFindClusters.cxx
AlgorithmMetricGradient.cxx
AlgorithmMetricReduce.cxx
AlgorithmMetricRegression.cxx
AlgorithmMetricRemoveIslands.cxx
AlgorithmMetricResample.cxx
AlgorithmMetricROIsFromExtrema.cxx
AlgorithmMetricROIsToBorder.cxx
AlgorithmMetricSmoothing.cxx
AlgorithmMetricTFCE.cxx
AlgorithmMetricToVolumeMapping.cxx
AlgorithmMetricVectorOperation.cxx
AlgorithmMetricVectorTowardROI.cxx
AlgorithmNodesInsideBorder.cxx
AlgorithmSignedDistanceToSurface.cxx
AlgorithmSurfaceAffineRegression.cxx
AlgorithmSurfaceApplyAffine.cxx
AlgorithmSurfaceApplyWarpfield.cxx
AlgorithmSurfaceAverage.cxx
AlgorithmSurfaceCortexLayer.cxx
AlgorithmSurfaceCreateSphere.cxx
AlgorithmSurfaceCurvature.cxx
AlgorithmSurfaceDistortion.cxx
AlgorithmSurfaceFlipLR.cxx
AlgorithmSurfaceGenerateInflated.cxx
AlgorithmSurfaceInflation.cxx
AlgorithmSurfaceMatch.cxx
AlgorithmSurfaceModifySphere.cxx
AlgorithmSurfaceResample.cxx
AlgorithmSurfaceSmoothing.cxx
AlgorithmSurfaceSphereProjectUnproject.cxx
AlgorithmSurfaceToSurface3dDistance.cxx
AlgorithmSurfaceWedgeVolume.cxx
AlgorithmVolumeAffineResample.cxx
AlgorithmVolumeAllLabelsToROIs.cxx
AlgorithmVolumeDilate.cxx
AlgorithmVolumeDistortion.cxx
AlgorithmVolumeErode.cxx
AlgorithmVolumeEstimateFWHM.cxx
AlgorithmVolumeExtrema.cxx
AlgorithmVolumeFillHoles.cxx
AlgorithmVolumeFindClusters.cxx
AlgorithmVolumeGradient.cxx
AlgorithmVolumeLabelProbability.cxx
AlgorithmVolumeLabelToROI.cxx
AlgorithmVolumeLabelToSurfaceMapping.cxx
AlgorithmVolumeParcelResampling.cxx
AlgorithmVolumeParcelResamplingGeneric.cxx
AlgorithmVolumeParcelSmoothing.cxx
AlgorithmVolumeReduce.cxx
AlgorithmVolumeRemoveIslands.cxx
AlgorithmVolumeROIsFromExtrema.cxx
AlgorithmVolumeSmoothing.cxx
AlgorithmVolumeTFCE.cxx
AlgorithmVolumeToSurfaceMapping.cxx
AlgorithmVolumeVectorOperation.cxx
AlgorithmVolumeWarpfieldAffineRegression.cxx
AlgorithmVolumeWarpfieldResample.cxx
OverlapLogicEnum.cxx
)

TARGET_LINK_LIBRARIES(Algorithms ${CARET_QT5_LINK})

#
# Find Headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Algorithms
${CMAKE_SOURCE_DIR}/Annotations
${CMAKE_SOURCE_DIR}/OperationsBase
${CMAKE_SOURCE_DIR}/FilesBase
${CMAKE_SOURCE_DIR}/Files
${CMAKE_SOURCE_DIR}/Gifti
${CMAKE_SOURCE_DIR}/Cifti
${CMAKE_SOURCE_DIR}/Palette
${CMAKE_SOURCE_DIR}/Nifti
${CMAKE_SOURCE_DIR}/Scenes
${CMAKE_SOURCE_DIR}/Xml
${CMAKE_SOURCE_DIR}/Charting
${CMAKE_SOURCE_DIR}/Common
)

=== src/Annotations/CMakeLists.txt ===
#
# Name of Project
#
PROJECT (Annotations)

#
# Use XML from Qt but not GUI.
#
SET(QT_DONT_USE_QTGUI TRUE)

#
# QT include files
#
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    #include_directories(${Qt5Network_INCLUDE_DIRS})
    include_directories(${Qt5Xml_INCLUDE_DIRS})
endif()

###INCLUDE(${QT_USE_FILE})

#
# Create a Library
#
ADD_LIBRARY(Annotations
Annotation.h
AnnotationAlignmentEnum.h
AnnotationAttributesDefaultTypeEnum.h
AnnotationBox.h
AnnotationColorBar.h
AnnotationColorBarNumericText.h
AnnotationColorBarPositionModeEnum.h
AnnotationColorBarSection.h
AnnotationCoordinate.h
AnnotationCoordinateSpaceEnum.h
AnnotationDistributeEnum.h
AnnotationFontAttributesInterface.h
AnnotationGroup.h
AnnotationGroupKey.h
AnnotationGroupTypeEnum.h
AnnotationGroupingModeEnum.h
AnnotationImage.h
AnnotationLine.h
AnnotationOneDimensionalShape.h
AnnotationOval.h
AnnotationPercentSizeText.h
AnnotationPointSizeText.h
AnnotationRedoUndoCommand.h
AnnotationRedoUndoCommandModeEnum.h
AnnotationEditingSelectionInformation.h
AnnotationSizingHandleTypeEnum.h
AnnotationSpatialModification.h
AnnotationSurfaceOffsetVectorTypeEnum.h
AnnotationText.h
AnnotationTextAlignHorizontalEnum.h
AnnotationTextAlignVerticalEnum.h
AnnotationTextConnectTypeEnum.h
AnnotationTextFontNameEnum.h
AnnotationTextFontPointSizeEnum.h
AnnotationTextFontSizeTypeEnum.h
AnnotationTextOrientationEnum.h
AnnotationTwoDimensionalShape.h
AnnotationTypeEnum.h
EventAnnotationAddToRemoveFromFile.h
EventAnnotationChartLabelGet.h
EventAnnotationGroupGetWithKey.h
EventAnnotationGrouping.h
EventAnnotationTextSubstitutionGet.h
EventAnnotationTextSubstitutionInvalidate.h

Annotation.cxx
AnnotationAlignmentEnum.cxx
AnnotationAttributesDefaultTypeEnum.cxx
AnnotationBox.cxx
AnnotationColorBar.cxx
AnnotationColorBarNumericText.cxx
AnnotationColorBarPositionModeEnum.cxx
AnnotationColorBarSection.cxx
AnnotationCoordinate.cxx
AnnotationCoordinateSpaceEnum.cxx
AnnotationDistributeEnum.cxx
AnnotationGroup.cxx
AnnotationGroupKey.cxx
AnnotationGroupTypeEnum.cxx
AnnotationGroupingModeEnum.cxx
AnnotationImage.cxx
AnnotationLine.cxx
AnnotationOneDimensionalShape.cxx
AnnotationOval.cxx
AnnotationPercentSizeText.cxx
AnnotationPointSizeText.cxx
AnnotationRedoUndoCommand.cxx
AnnotationRedoUndoCommandModeEnum.cxx
AnnotationEditingSelectionInformation.cxx
AnnotationSizingHandleTypeEnum.cxx
AnnotationSpatialModification.cxx
AnnotationSurfaceOffsetVectorTypeEnum.cxx
AnnotationText.cxx
AnnotationTextAlignHorizontalEnum.cxx
AnnotationTextAlignVerticalEnum.cxx
AnnotationTextConnectTypeEnum.cxx
AnnotationTextFontNameEnum.cxx
AnnotationTextFontPointSizeEnum.cxx
AnnotationTextFontSizeTypeEnum.cxx
AnnotationTextOrientationEnum.cxx
AnnotationTwoDimensionalShape.cxx
AnnotationTypeEnum.cxx
EventAnnotationAddToRemoveFromFile.cxx
EventAnnotationChartLabelGet.cxx
EventAnnotationGroupGetWithKey.cxx
EventAnnotationGrouping.cxx
EventAnnotationTextSubstitutionGet.cxx
EventAnnotationTextSubstitutionInvalidate.cxx
)

TARGET_LINK_LIBRARIES(Annotations ${CARET_QT5_LINK})

#
# Find headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Common
${CMAKE_SOURCE_DIR}/Graphics
${CMAKE_SOURCE_DIR}/Scenes
${CMAKE_SOURCE_DIR}/Nifti
)

=== src/Charting/CMakeLists.txt ===

#
# Name of Project
#
PROJECT(Charting)

#
# Qt include files
#
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
endif()

#
# Create a library
#
ADD_LIBRARY(Charting
ChartAxis.h
ChartAxisCartesian.h
ChartAxisLocationEnum.h
ChartAxisTypeEnum.h
ChartAxisUnitsEnum.h
ChartData.h
ChartDataCartesian.h
ChartDataSource.h
ChartDataSourceModeEnum.h
ChartMatrixDisplayProperties.h
ChartMatrixLoadingDimensionEnum.h
ChartMatrixScaleModeEnum.h
ChartModel.h
ChartModelCartesian.h
ChartModelDataSeries.h
ChartModelFrequencySeries.h
ChartModelTimeSeries.h
ChartPoint.h
ChartScaleAutoRanging.h
ChartSelectionModeEnum.h
ChartOneDataTypeEnum.h
ChartingVersionEnum.h

ChartTwoAxisScaleRangeModeEnum.h
ChartTwoCartesianAxis.h
ChartTwoCompoundDataType.h
ChartTwoDataCartesian.h
ChartTwoDataTypeEnum.h
ChartTwoHistogramContentTypeEnum.h
ChartTwoLineSeriesContentTypeEnum.h
ChartTwoMatrixContentTypeEnum.h
ChartTwoMatrixDisplayProperties.h
ChartTwoMatrixLoadingDimensionEnum.h
ChartTwoMatrixTriangularViewingModeEnum.h
ChartTwoNumericSubdivisionsModeEnum.h
ChartTwoLineSeriesHistory.h
ChartTwoTitle.h
EventChartTwoAttributesChanged.h
EventChartTwoAxisGetDataRange.h
EventChartTwoLoadLineSeriesData.h
MapFileDataSelector.h

ChartTwoAxisScaleRangeModeEnum.cxx
ChartAxis.cxx
ChartAxisCartesian.cxx
ChartAxisLocationEnum.cxx
ChartAxisTypeEnum.cxx
ChartAxisUnitsEnum.cxx
ChartData.cxx
ChartDataCartesian.cxx
ChartDataSource.cxx
ChartDataSourceModeEnum.cxx
ChartMatrixDisplayProperties.cxx
ChartMatrixLoadingDimensionEnum.cxx
ChartMatrixScaleModeEnum.cxx
ChartModel.cxx
ChartModelCartesian.cxx
ChartModelDataSeries.cxx
ChartModelFrequencySeries.cxx
ChartModelTimeSeries.cxx
ChartPoint.cxx
ChartScaleAutoRanging.cxx
ChartSelectionModeEnum.cxx
ChartOneDataTypeEnum.cxx
ChartingVersionEnum.cxx

ChartTwoCartesianAxis.cxx
ChartTwoCompoundDataType.cxx
ChartTwoDataCartesian.cxx
ChartTwoDataTypeEnum.cxx
ChartTwoHistogramContentTypeEnum.cxx
ChartTwoLineSeriesContentTypeEnum.cxx
ChartTwoMatrixContentTypeEnum.cxx
ChartTwoMatrixDisplayProperties.cxx
ChartTwoMatrixLoadingDimensionEnum.cxx
ChartTwoMatrixTriangularViewingModeEnum.cxx
ChartTwoNumericSubdivisionsModeEnum.cxx
ChartTwoLineSeriesHistory.cxx
ChartTwoTitle.cxx
EventChartTwoAttributesChanged.cxx
EventChartTwoAxisGetDataRange.cxx
EventChartTwoLoadLineSeriesData.cxx
MapFileDataSelector.cxx
)

TARGET_LINK_LIBRARIES(Charting ${CARET_QT5_LINK})

#
# Include directories
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Annotations
${CMAKE_SOURCE_DIR}/Charting
${CMAKE_SOURCE_DIR}/Common
${CMAKE_SOURCE_DIR}/Graphics
${CMAKE_SOURCE_DIR}/Scenes
)

=== src/Common/CMakeLists.txt ===

#
# Name of Project
#
PROJECT(Common)


#
# QT include files
#
SET(QT_USE_QTXML TRUE)
SET(QT_DONT_USE_QTGUI TRUE)
SET(QT_USE_QTNETWORK TRUE)

if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    include_directories(${Qt5Network_INCLUDE_DIRS})
    include_directories(${Qt5Xml_INCLUDE_DIRS})
endif()
IF (QT4_FOUND)
    INCLUDE(${QT_USE_FILE})
ENDIF ()
#message("QT VERSION: " ${QT_VERSION_MAJOR} ${QT_VERSION_MINOR} ${QT_VERSION_PATCH})

#
# With AUTOMOC, do not need to specify files
# that contain Q_OBJECT macro for Qt to process with 'moc'
# (meta-object compiler).
#
IF(WORKBENCH_USE_CMAKE_AUTOMOC)
    SET(CMAKE_AUTOMOC ON)
ELSE()
    SET(MOC_INPUT_HEADER_FILES
        CaretHttpManager.h
    )

    IF(Qt5_FOUND)
        QT5_WRAP_CPP(MOC_SOURCE_FILES ${MOC_INPUT_HEADER_FILES})
    ENDIF()
    IF (QT4_FOUND)
        QT4_WRAP_CPP(MOC_SOURCE_FILES ${MOC_INPUT_HEADER_FILES})
    ENDIF ()
ENDIF()

#
# Create a library
#
ADD_LIBRARY(Common
ApplicationInformation.h
ApplicationTypeEnum.h
AString.h
AStringNaturalComparison.h
BackgroundAndForegroundColors.h
BackgroundAndForegroundColorsModeEnum.h
Base64.h
BoundingBox.h
BrainConstants.h
ByteOrderEnum.h
ByteSwapping.h
CaretAssert.h
CaretAssertion.h
CaretBinaryFile.h
CaretColorEnum.h
CaretCommandLine.h
CaretCompact3DLookup.h
CaretCompactLookup.h
CaretException.h
CaretFunctionName.h
CaretHeap.h
CaretHttpManager.h
CaretLogger.h
CaretMathExpression.h
CaretMutex.h
CaretObject.h
CaretObjectTracksModification.h
CaretOMP.h
CaretPointer.h
CaretPointLocator.h
CaretPreferences.h
CaretTemporaryFile.h
CaretUndoCommand.h
CaretUndoStack.h
CaretUnitsTypeEnum.h
CubicSpline.h
DataCompressZLib.h
DataFile.h
DataFileContentCopyMoveInterface.h
DataFileContentCopyMoveParameters.h
DataFileContentInformation.h
DataFileException.h
DataFileInterface.h
DataFileTypeEnum.h
DescriptiveStatistics.h
DeveloperFlagsEnum.h
DisplayGroupAndTabItemInterface.h 
DisplayGroupEnum.h
ElapsedTimer.h
Event.h
EventAlertUser.h
EventBrowserTabDelete.h
EventBrowserTabIndicesGetAll.h
EventCaretPreferencesGet.h
EventGetViewportSize.h
EventListenerInterface.h
EventManager.h
EventPaletteGetByName.h
EventProgressUpdate.h
EventTypeEnum.h
FastStatistics.h
FileAdapter.h
FileInformation.h
FloatMatrix.h
Histogram.h
HtmlStringBuilder.h
ImageCaptureMethodEnum.h
JsonHelper.h
Logger.h
LogHandler.h
LogHandlerStandardError.h
LogLevelEnum.h
LogManager.h
LogRecord.h
MathFunctionEnum.h
MathFunctions.h
MatrixFunctions.h
ModelTransform.h
MultiDimArray.h
MultiDimIterator.h
NetworkException.h
NumericFormatModeEnum.h
NumericTextFormatting.h
OctTree.h
OpenGLDrawingMethodEnum.h
PlainTextStringBuilder.h
Plane.h
ProgramParameters.h
ProgramParametersException.h
ProgressObject.h
ProgressReportingInterface.h
ReductionEnum.h
ReductionOperation.h
SpecFileDialogViewFilesTypeEnum.h
SpeciesEnum.h
StereotaxicSpaceEnum.h
StringTableModel.h
StructureEnum.h
SystemUtilities.h
TileTabsConfiguration.h
TileTabsConfigurationModeEnum.h
TracksModificationInterface.h
TriStateSelectionStatusEnum.h
Vector3D.h
VectorOperation.h
VoxelIJK.h
WorkbenchSpecialVersionEnum.h
YokingGroupEnum.h

${MOC_SOURCE_FILES}

${CMAKE_BINARY_DIR}/Common/ApplicationInformation.cxx
ApplicationTypeEnum.cxx
AString.cxx
AStringNaturalComparison.cxx
BackgroundAndForegroundColors.cxx
BackgroundAndForegroundColorsModeEnum.cxx
Base64.cxx
BoundingBox.cxx
BrainConstants.cxx
ByteOrderEnum.cxx
ByteSwapping.cxx
CaretAssertion.cxx
CaretBinaryFile.cxx
CaretColorEnum.cxx
CaretCommandLine.cxx
CaretException.cxx
CaretHttpManager.cxx
CaretLogger.cxx
CaretMathExpression.cxx
CaretObject.cxx
CaretObjectTracksModification.cxx
CaretPointLocator.cxx
CaretPreferences.cxx
CaretTemporaryFile.cxx
CaretUndoCommand.cxx
CaretUndoStack.cxx
CaretUnitsTypeEnum.cxx
CubicSpline.cxx
DataCompressZLib.cxx
DataFile.cxx
DataFileContentCopyMoveParameters.cxx
DataFileContentInformation.cxx
DataFileException.cxx
DataFileTypeEnum.cxx
DescriptiveStatistics.cxx
DeveloperFlagsEnum.cxx
DisplayGroupAndTabItemInterface.cxx
DisplayGroupEnum.cxx
ElapsedTimer.cxx
Event.cxx
EventAlertUser.cxx
EventBrowserTabDelete.cxx
EventBrowserTabIndicesGetAll.cxx
EventCaretPreferencesGet.cxx
EventGetViewportSize.cxx
EventListenerInterface.cxx
EventManager.cxx
EventPaletteGetByName.cxx
EventProgressUpdate.cxx
EventTypeEnum.cxx
FastStatistics.cxx
FileAdapter.cxx
FileInformation.cxx
FloatMatrix.cxx
Histogram.cxx
HtmlStringBuilder.cxx
ImageCaptureMethodEnum.cxx
JsonHelper.cxx
Logger.cxx
LogHandler.cxx
LogHandlerStandardError.cxx
LogLevelEnum.cxx
LogManager.cxx
LogRecord.cxx
MathFunctionEnum.cxx
MathFunctions.cxx
ModelTransform.cxx
NetworkException.cxx
NumericFormatModeEnum.cxx
NumericTextFormatting.cxx
OpenGLDrawingMethodEnum.cxx
PlainTextStringBuilder.cxx
Plane.cxx
ProgramParameters.cxx
ProgramParametersException.cxx
ProgressObject.cxx
ReductionEnum.cxx
ReductionOperation.cxx
SpecFileDialogViewFilesTypeEnum.cxx
SpeciesEnum.cxx
StereotaxicSpaceEnum.cxx
StringTableModel.cxx
StructureEnum.cxx
SystemUtilities.cxx
TileTabsConfiguration.cxx
TileTabsConfigurationModeEnum.cxx
TriStateSelectionStatusEnum.cxx
Vector3D.cxx
VectorOperation.cxx
WorkbenchSpecialVersionEnum.cxx
YokingGroupEnum.cxx
)

ADD_DEFINITIONS(-DCOMPILER_NAME="${CMAKE_CXX_COMPILER}")
ADD_DEFINITIONS(-DCOMPILER_VERSION="${CMAKE_CXX_COMPILER_VERSION}")

#
# Include directories
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Common
)

SET (GIT_REPOSITORY "${CMAKE_SOURCE_DIR}/../.git")
IF (EXISTS ${GIT_REPOSITORY})
    ADD_CUSTOM_COMMAND(
        OUTPUT ${CMAKE_BINARY_DIR}/Common/ApplicationInformation.cxx
        COMMAND ${CMAKE_COMMAND}
            -DINFILE="${CMAKE_SOURCE_DIR}/Common/ApplicationInformation.cxx.in"
            -DOUTFILE="${CMAKE_BINARY_DIR}/Common/ApplicationInformation.cxx"
            -P "${CMAKE_SOURCE_DIR}/CMakeScripts/git_commit_info.cmake.in"
        WORKING_DIRECTORY ${GIT_REPOSITORY}/..
        DEPENDS ApplicationInformation.cxx.in ${CMAKE_SOURCE_DIR}/CMakeScripts/git_commit_info.cmake.in ${GIT_REPOSITORY}/HEAD ${GIT_REPOSITORY}/index
        COMMENT "Setting commit info"
    )
ELSE(EXISTS ${GIT_REPOSITORY})
    ADD_CUSTOM_COMMAND(
        OUTPUT ${CMAKE_BINARY_DIR}/Common/ApplicationInformation.cxx
        COMMAND ${CMAKE_COMMAND}
            -DINFILE="${CMAKE_SOURCE_DIR}/Common/ApplicationInformation.cxx.in"
            -DOUTFILE="${CMAKE_BINARY_DIR}/Common/ApplicationInformation.cxx"
            -P "${CMAKE_SOURCE_DIR}/CMakeScripts/git_commit_info.cmake.in"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/..
        DEPENDS ApplicationInformation.cxx.in ${CMAKE_SOURCE_DIR}/CMakeScripts/git_commit_info.cmake.in
        COMMENT "No repository found, setting commit info to 'unknown'.  Reconfigure to look for the repository again."
    )
ENDIF(EXISTS ${GIT_REPOSITORY})

#
# Conditionally link the dot library to use the SIMD-based dot product implementation
#
IF (WORKBENCH_USE_SIMD AND CPUINFO_COMPILES)
    TARGET_LINK_LIBRARIES(Common dot ${CARET_QT5_LINK})
ELSE (WORKBENCH_USE_SIMD AND CPUINFO_COMPILES)
    TARGET_LINK_LIBRARIES(Common ${CARET_QT5_LINK})
ENDIF (WORKBENCH_USE_SIMD AND CPUINFO_COMPILES)

=== src/Desktop/CMakeLists.txt ===
#
# Name of Project
#
PROJECT(Desktop)

#
# Name of executable
#
set (EXE_NAME wb_view)

#
# QT Include directories
#
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    include_directories(${Qt5Network_INCLUDE_DIRS})
    if(Qt5OpenGL_FOUND)
        include_directories(${Qt5OpenGL_INCLUDE_DIRS})
    endif()
    include_directories(${Qt5Widgets_INCLUDE_DIRS})
endif()
IF (QT4_FOUND)
    SET(QT_USE_QTXML TRUE)
    SET(QT_USE_QTOPENGL TRUE)
    SET(QT_USE_QTNETWORK TRUE)
    INCLUDE(${QT_USE_FILE})
ENDIF ()


#
# Added by JWH to eliminate OpenGL linking errors in Ubuntu Linux
#
IF (UNIX)
    IF (NOT APPLE)
        FIND_PACKAGE(OpenGL)
    ENDIF (NOT APPLE)
ENDIF (UNIX)

#
# Resources
#
SET (RESOURCES_QRC_FILE
     ../Resources/General/general_resources.qrc
     ../Resources/Gui/gui_resources.qrc
     ../Resources/Help/help_resources.qrc)
IF (Qt5_FOUND)
    QT5_ADD_RESOURCES(IMAGE_RCS_SRCS ${RESOURCES_QRC_FILE})
ELSE (Qt5_FOUND)
    IF (QT4_FOUND)
        QT4_ADD_RESOURCES(IMAGE_RCS_SRCS ${RESOURCES_QRC_FILE})
    ENDIF()
ENDIF (Qt5_FOUND)

#
# Create the executable
# Apple creates a bundle
#
IF (APPLE)
   ADD_EXECUTABLE(${EXE_NAME}
      MACOSX_BUNDLE
      desktop.cxx
      ${IMAGE_RCS_SRCS}
   )

    #
    # This is a customized Info.Plist for Mac so that a spec
    # file can be opened using Finder
    #
    SET_TARGET_PROPERTIES(
	${EXE_NAME}
	PROPERTIES
	MACOSX_BUNDLE_INFO_PLIST 
	${CMAKE_SOURCE_DIR}/../mac_plist/MacOSXBundleInfo.plist.in
    )
	
#   SET_TARGET_PROPERTIES(
#       ${EXE_NAME}
#       PROPERTIES
#       RESOURCE
#       ${QT_BINARY_DIR}/../src/gui/mac/qt_menu.nib
#   )
ENDIF (APPLE)

IF (WIN32)
   ADD_EXECUTABLE(${EXE_NAME}
      desktop.cxx
      ${IMAGE_RCS_SRCS}
      ${CMAKE_SOURCE_DIR}/../icons/windows/workbench.rc
   )
ENDIF (WIN32)
IF (NOT APPLE)
    IF (UNIX)
       ADD_EXECUTABLE(${EXE_NAME}
          desktop.cxx
          ${IMAGE_RCS_SRCS}
       )
    ENDIF (UNIX)
ENDIF (NOT APPLE)

if(Qt5OpenGL_FOUND)
    set(QT5_OPENGL_LIB_NAME Qt5::OpenGL)
endif()
if(Qt5_FOUND)
    set(QT5_LINK_LIBS
        Qt5::Concurrent
        Qt5::Core
        Qt5::Gui
        Qt5::Network
        ${QT5_OPENGL_LIB_NAME}
        Qt5::PrintSupport
        Qt5::Test
        Qt5::Widgets
        Qt5::Xml)
endif()

#
# Libraries that are linked
#
TARGET_LINK_LIBRARIES(${EXE_NAME}
GuiQt
Commands
Operations
Algorithms
OperationsBase
${Qwt_LIBRARIES}
OSMesaDummy
Brain
Files
Graphics
${FTGL_LIBRARIES}
Annotations
Charting
Palette
Cifti
Gifti
Nifti
QxtCore
FilesBase
Scenes
Xml
Common
${GLEW_LIBRARIES}
${QUAZIP_LIBRARIES}
${FREETYPE_LIBRARIES}
${QT_LIBRARIES}
${QT5_LINK_LIBS}
${ZLIB_LIBRARIES}
#${LIBS}
)

INCLUDE(GNUInstallDirs)

INSTALL(TARGETS ${EXE_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})

IF(WIN32)
    TARGET_LINK_LIBRARIES(${EXE_NAME}
    opengl32
    glu32
    )
ENDIF(WIN32)

IF (UNIX)
   IF (NOT APPLE) 
      TARGET_LINK_LIBRARIES(${EXE_NAME}
         ${OPENGL_LIBRARIES}
         gobject-2.0
      )
   ENDIF (NOT APPLE)

#   EXECUTE_PROCESS(COMMAND uname -n OUTPUT_VARIABLE MACHINE_NAME)
#   MESSAGE("MACHINE_NAME: ${MACHINE_NAME}")
#   IF (${MACHINE_NAME} MATCHES "linuxbuild")
#       MESSAGE("is linuxbuild")
#       SET_TARGET_PROPERTIES(${EXE_NAME}
#                          PROPERTIES
#                          LINK_FLAGS "-Wl,-E"
#                          LINK_FLAGS_DEBUG "-Wl,-E"
#                          LINK_FLAGS_RELEASE "-Wl,-E")
#   ENDIF()
ENDIF (UNIX)

#
# At this time, Cocoa needs to be explicitly added for Apple Mac
#
IF (APPLE)
   #SET (QT_MAC_USE_COCOA TRUE)
   TARGET_LINK_LIBRARIES(${EXE_NAME}
     "-framework Cocoa"
     "-framework OpenGL"
   )
ENDIF (APPLE)

#
# Find Headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Desktop
${CMAKE_SOURCE_DIR}/Algorithms
${CMAKE_SOURCE_DIR}/Commands
${CMAKE_SOURCE_DIR}/GuiQt
${CMAKE_SOURCE_DIR}/Brain
${CMAKE_SOURCE_DIR}/Graphics
${CMAKE_SOURCE_DIR}/FilesBase
${CMAKE_SOURCE_DIR}/Files
${CMAKE_SOURCE_DIR}/Palette
${CMAKE_SOURCE_DIR}/Cifti
${CMAKE_SOURCE_DIR}/Gifti
${CMAKE_SOURCE_DIR}/Nifti
${Qwt_INCLUDE_DIRS}
${CMAKE_SOURCE_DIR}/Scenes
${CMAKE_SOURCE_DIR}/Xml
${CMAKE_SOURCE_DIR}/Common
)

#
# Apple needs qt_menu.nib directory copied
# into application's Resources directory 
#
# Apple needs framework
#
IF (APPLE)
        ADD_CUSTOM_COMMAND(
            TARGET ${EXE_NAME}
            POST_BUILD
            COMMAND ${CMAKE_SOURCE_DIR}/CMakeScripts/copy_mac_nib.sh ${EXE_NAME}
            ###COMMAND ${CMAKE_SOURCE_DIR}/CMakeScripts/copy_mac_frameworks.sh ${EXE_NAME}
        )
ENDIF (APPLE)

IF (APPLE)
    SET (MACOSX_BUNDLE_INFO_STRING wb_view Copyright 2015 )
    SET (MACOSX_BUNDLE_ICON_FILE workbench.icns )
    ##SET (MACOSX_BUNDLE_GUI_IDENTIFIER wb_view )
    ## Underscore is not valid in MACOSX_BUNDLE_GUI_IDENTIFIER
    SET (MACOSX_BUNDLE_GUI_IDENTIFIER workbench )
    SET (MACOSX_BUNDLE_LONG_VERSION_STRING wb_view)
    SET (MACOSX_BUNDLE_BUNDLE_NAME wb_view)
    SET (MACOSX_BUNDLE_SHORT_VERSION_STRING 1.3.2)
    SET (MACOSX_BUNDLE_BUNDLE_VERSION 1.3.2)
    SET (MACOSX_BUNDLE_COPYRIGHT  2015 )

    ADD_CUSTOM_COMMAND(
        TARGET ${EXE_NAME}
        POST_BUILD
        COMMAND ${CMAKE_SOURCE_DIR}/CMakeScripts/copy_mac_icon.sh ${EXE_NAME} ${CMAKE_SOURCE_DIR}/../icons/mac/wb_view.icns
        COMMAND ${CMAKE_SOURCE_DIR}/CMakeScripts/copy_mac_icon.sh ${EXE_NAME} ${CMAKE_SOURCE_DIR}/../icons/mac/workbench.icns
        COMMAND ${CMAKE_SOURCE_DIR}/CMakeScripts/copy_mac_icon.sh ${EXE_NAME} ${CMAKE_SOURCE_DIR}/../icons/mac/spec_file.icns
        COMMAND ${CMAKE_SOURCE_DIR}/CMakeScripts/copy_mac_icon.sh ${EXE_NAME} ${CMAKE_SOURCE_DIR}/../icons/mac/data_file.icns
    )
ENDIF (APPLE)

=== src/Files/CMakeLists.txt ===
#
# Name of project
#
PROJECT (Files)

#
# Add QT for includes
#
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    include_directories(${Qt5Gui_INCLUDE_DIRS})
    include_directories(${Qt5Network_INCLUDE_DIRS})
endif()
IF (QT4_FOUND)
    SET(QT_DONT_USE_QTGUI)
    SET(QT_USE_QTNETWORK TRUE)
    INCLUDE(${QT_USE_FILE})
ENDIF ()

#
# Files Library
#
ADD_LIBRARY(Files
AffineFile.h
AnnotationFile.h
AnnotationFileXmlFormatBase.h
AnnotationFileXmlReader.h
AnnotationFileXmlWriter.h
AnnotationTextSubstitutionFile.h
Border.h
BorderException.h
BorderFile.h
BorderLengthHelper.h
BorderPointFromSearch.h
BorderTracingHelper.h
BrainordinateRegionOfInterest.h
CaretDataFile.h
CaretDataFileHelper.h
CaretDataFileSelectionModel.h
CaretMappableDataFile.h
CaretMappableDataFileAndMapSelectionModel.h
CaretSparseFile.h
CaretVolumeExtension.h
ChartableLineSeriesBrainordinateInterface.h
ChartableLineSeriesInterface.h
ChartableLineSeriesRowColumnInterface.h
ChartableMatrixInterface.h
ChartableMatrixParcelInterface.h
ChartableMatrixSeriesInterface.h
ChartableTwoFileDelegate.h
ChartableTwoFileBaseChart.h
ChartableTwoFileHistogramChart.h
ChartableTwoFileLineSeriesChart.h
ChartableTwoFileMatrixChart.h
CiftiBrainordinateDataSeriesFile.h
CiftiBrainordinateLabelFile.h
CiftiBrainordinateScalarFile.h
CiftiConnectivityMatrixDenseFile.h
CiftiConnectivityMatrixDenseDynamicFile.h
CiftiConnectivityMatrixDenseParcelFile.h
CiftiConnectivityMatrixParcelFile.h
CiftiConnectivityMatrixParcelDenseFile.h
CiftiFiberOrientationFile.h
CiftiFiberTrajectoryFile.h
CiftiMappableDataFile.h
CiftiMappableConnectivityMatrixDataFile.h
CiftiParcelColoringModeEnum.h
CiftiParcelLabelFile.h
CiftiParcelReordering.h
CiftiParcelReorderingModel.h
CiftiParcelSeriesFile.h
CiftiParcelScalarFile.h
CiftiScalarDataSeriesFile.h
ConnectivityDataLoaded.h
ControlPointFile.h
EventCaretDataFilesGet.h
EventCaretMappableDataFileMapsViewedInOverlays.h
EventCaretMappableDataFilesGet.h
EventChartMatrixParcelYokingValidation.h
EventGetDisplayedDataFiles.h
EventMapYokingSelectMap.h
EventMapYokingValidation.h
EventSurfaceColoringInvalidate.h
EventSurfaceStructuresValidGet.h
Fiber.h
FiberOrientation.h
FiberOrientationColoringTypeEnum.h
FiberOrientationTrajectory.h
FiberTrajectoryColorModel.h
FiberTrajectoryMapProperties.h
FiberTrajectoryDisplayModeEnum.h
FilePathNamePrefixCompactor.h
FociFile.h
FociFileSaxReader.h
Focus.h
GeodesicHelper.h
GiftiTypeFile.h
GroupAndNameCheckStateEnum.h
GroupAndNameHierarchyGroup.h
GroupAndNameHierarchyItem.h
GroupAndNameHierarchyModel.h
GroupAndNameHierarchyName.h
ImageCaptureDimensionsModeEnum.h
ImageCaptureSettings.h
ImageFile.h
ImageResolutionUnitsEnum.h
ImageSpatialUnitsEnum.h
LabelDrawingProperties.h
LabelDrawingTypeEnum.h
LabelFile.h
MapYokingGroupEnum.h
MetricFile.h
MetricSmoothingObject.h
NodeAndVoxelColoring.h
OxfordSparseThreeFile.h
PaletteFile.h
RgbaFile.h
RibbonMappingHelper.h
SceneFile.h
SceneFileSaxReader.h
SignedDistanceHelper.h
SparseVolumeIndexer.h
SpecFile.h
SpecFileDataFileTypeGroup.h
SpecFileDataFile.h
SpecFileSaxReader.h
StudyMetaDataLink.h
StudyMetaDataLinkSet.h
StudyMetaDataLinkSetSaxReader.h
SurfaceFile.h
SurfacePlaneIntersectionToContour.h
SurfaceProjectedItem.h
SurfaceProjectedItemSaxReader.h
SurfaceProjection.h
SurfaceProjectionBarycentric.h
SurfaceProjectionVanEssen.h
SurfaceProjector.h
SurfaceProjectorException.h
SurfaceResamplingHelper.h
SurfaceResamplingMethodEnum.h
SurfaceTypeEnum.h
TextFile.h
TopologyHelper.h
VolumeEditingModeEnum.h
VolumeFile.h
VolumeFileEditorDelegate.h
VolumeFileVoxelColorizer.h
VolumeMapUndoCommand.h
VolumePaddingHelper.h
VolumeSliceProjectionTypeEnum.h
VolumeSpline.h
VtkFileExporter.h
WarpfieldFile.h
XmlStreamReaderHelper.h
XmlStreamWriterHelper.h

AffineFile.cxx
AnnotationFile.cxx
AnnotationFileXmlFormatBase.cxx
AnnotationFileXmlReader.cxx
AnnotationFileXmlWriter.cxx
AnnotationTextSubstitutionFile.cxx
Border.cxx
BorderException.cxx
BorderFile.cxx
BorderLengthHelper.cxx
BorderTracingHelper.cxx
BrainordinateRegionOfInterest.cxx
CaretDataFile.cxx
CaretDataFileHelper.cxx
CaretDataFileSelectionModel.cxx
CaretMappableDataFile.cxx
CaretMappableDataFileAndMapSelectionModel.cxx
CaretSparseFile.cxx
CaretVolumeExtension.cxx
ChartableLineSeriesInterface.cxx
ChartableMatrixInterface.cxx
ChartableTwoFileDelegate.cxx
ChartableTwoFileBaseChart.cxx
ChartableTwoFileHistogramChart.cxx
ChartableTwoFileLineSeriesChart.cxx
ChartableTwoFileMatrixChart.cxx
CiftiBrainordinateDataSeriesFile.cxx
CiftiBrainordinateLabelFile.cxx
CiftiBrainordinateScalarFile.cxx
CiftiConnectivityMatrixDenseFile.cxx
CiftiConnectivityMatrixDenseDynamicFile.cxx
CiftiConnectivityMatrixDenseParcelFile.cxx
CiftiConnectivityMatrixParcelFile.cxx
CiftiConnectivityMatrixParcelDenseFile.cxx
CiftiFiberOrientationFile.cxx
CiftiFiberTrajectoryFile.cxx
CiftiMappableDataFile.cxx
CiftiMappableConnectivityMatrixDataFile.cxx
CiftiParcelColoringModeEnum.cxx
CiftiParcelLabelFile.cxx
CiftiParcelReordering.cxx
CiftiParcelReorderingModel.cxx
CiftiParcelSeriesFile.cxx
CiftiParcelScalarFile.cxx
CiftiScalarDataSeriesFile.cxx
ConnectivityDataLoaded.cxx
ControlPointFile.cxx
EventCaretDataFilesGet.cxx
EventCaretMappableDataFileMapsViewedInOverlays.cxx
EventCaretMappableDataFilesGet.cxx
EventChartMatrixParcelYokingValidation.cxx
EventGetDisplayedDataFiles.cxx
EventMapYokingSelectMap.cxx
EventMapYokingValidation.cxx
EventSurfaceColoringInvalidate.cxx
EventSurfaceStructuresValidGet.cxx
Fiber.cxx
FiberOrientation.cxx
FiberOrientationColoringTypeEnum.cxx
FiberOrientationTrajectory.cxx
FiberTrajectoryColorModel.cxx
FiberTrajectoryDisplayModeEnum.cxx
FiberTrajectoryMapProperties.cxx
FilePathNamePrefixCompactor.cxx
FociFile.cxx
FociFileSaxReader.cxx
Focus.cxx
GeodesicHelper.cxx
GiftiTypeFile.cxx
GroupAndNameCheckStateEnum.cxx
GroupAndNameHierarchyGroup.cxx
GroupAndNameHierarchyItem.cxx
GroupAndNameHierarchyModel.cxx
GroupAndNameHierarchyName.cxx
ImageCaptureDimensionsModeEnum.cxx
ImageCaptureSettings.cxx
ImageFile.cxx
ImageResolutionUnitsEnum.cxx
ImageSpatialUnitsEnum.cxx
LabelDrawingProperties.cxx
LabelDrawingTypeEnum.cxx
LabelFile.cxx
MapYokingGroupEnum.cxx
MetricFile.cxx
MetricSmoothingObject.cxx
NodeAndVoxelColoring.cxx
OxfordSparseThreeFile.cxx
PaletteFile.cxx
RgbaFile.cxx
RibbonMappingHelper.cxx
SceneFile.cxx
SceneFileSaxReader.cxx
SignedDistanceHelper.cxx
SparseVolumeIndexer.cxx
SpecFile.cxx
SpecFileDataFileTypeGroup.cxx
SpecFileDataFile.cxx
SpecFileSaxReader.cxx
StudyMetaDataLink.cxx
StudyMetaDataLinkSet.cxx
StudyMetaDataLinkSetSaxReader.cxx
SurfaceFile.cxx
SurfacePlaneIntersectionToContour.cxx
SurfaceProjectedItem.cxx
SurfaceProjectedItemSaxReader.cxx
SurfaceProjection.cxx
SurfaceProjectionBarycentric.cxx
SurfaceProjectionVanEssen.cxx
SurfaceProjector.cxx
SurfaceProjectorException.cxx
SurfaceResamplingHelper.cxx
SurfaceResamplingMethodEnum.cxx
SurfaceTypeEnum.cxx
TextFile.cxx
TopologyHelper.cxx
VolumeEditingModeEnum.cxx
VolumeFile.cxx
VolumeFileEditorDelegate.cxx
VolumeFileVoxelColorizer.cxx
VolumeMapUndoCommand.cxx
VolumePaddingHelper.cxx
VolumeSliceProjectionTypeEnum.cxx
VolumeSpline.cxx
VtkFileExporter.cxx
WarpfieldFile.cxx
XmlStreamReaderHelper.cxx
XmlStreamWriterHelper.cxx
)

TARGET_LINK_LIBRARIES(Files ${CARET_QT5_LINK})

#
# Find Headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Annotations
${CMAKE_SOURCE_DIR}/Charting
${CMAKE_SOURCE_DIR}/Files
${CMAKE_SOURCE_DIR}/FilesBase
${CMAKE_SOURCE_DIR}/Graphics
${CMAKE_SOURCE_DIR}/Cifti
${CMAKE_SOURCE_DIR}/Palette
${CMAKE_SOURCE_DIR}/Gifti
${CMAKE_SOURCE_DIR}/Nifti
${CMAKE_SOURCE_DIR}/QxtCore
${CMAKE_SOURCE_DIR}/Scenes
${CMAKE_SOURCE_DIR}/Xml
${CMAKE_SOURCE_DIR}/Common
)

=== src/GuiQt/CMakeLists.txt ===

#
# Name of project
#
PROJECT (GuiQt)

#
# QT include files
#
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    include_directories(${Qt5OpenGL_INCLUDE_DIRS})
    include_directories(${Qt5Network_INCLUDE_DIRS})
    include_directories(${Qt5Widgets_INCLUDE_DIRS})
endif()
IF (QT4_FOUND)
    SET(QT_USE_QTNETWORK TRUE)
    SET(QT_USE_QTOPENGL TRUE)
    INCLUDE(${QT_USE_FILE})
ENDIF ()

#
# Let CMake find files for moc and uic.
#

#
# With AUTOMOC, do not need to specify files
# that contain Q_OBJECT macro for Qt to process with 'moc'
# (meta-object compiler).
#
IF(WORKBENCH_USE_CMAKE_AUTOMOC)
    SET(CMAKE_AUTOMOC ON)
    SET(CMAKE_AUTOUIC ON)
ELSE()
    SET(FORMS
        MovieDialog.ui
       )

    SET(MOC_INPUT_HEADER_FILES
        AboutWorkbenchDialog.h
        AnnotationChangeCoordinateDialog.h
        AnnotationColorWidget.h
        AnnotationCoordinateSelectionWidget.h
        AnnotationCoordinateSpaceWidget.h
        AnnotationCoordinateWidget.h
        AnnotationCreateDialog.h
        AnnotationDeleteWidget.h
        AnnotationFontWidget.h
        AnnotationFormatWidget.h
        AnnotationInsertNewWidget.h
        AnnotationLineArrowTipsWidget.h
        AnnotationMenuArrange.h
        AnnotationMenuFileSelection.h
        AnnotationRedoUndoWidget.h
        AnnotationRotationWidget.h
        AnnotationSelectionViewController.h
        AnnotationPasteDialog.h
        AnnotationTextAlignmentWidget.h
        AnnotationTextEditorDialog.h
        AnnotationTextEditorWidget.h
        AnnotationTextOrientationWidget.h
        AnnotationTextSubstitutionViewController.h
        AnnotationWidthHeightWidget.h
        BalsaDatabaseUploadSceneFileDialog.h
        BalsaStudySelectionDialog.h
        BorderEditingSelectionDialog.h
        BorderFileSplitDialog.h
        BorderOptimizeDialog.h
        BorderPropertiesEditorDialog.h
        BorderSelectionViewController.h
        BrainBrowserWindow.h
        BrainBrowserWindowComboBox.h
        BrainBrowserWindowOrientedToolBox.h
        BrainBrowserWindowToolBar.h
        BrainBrowserWindowToolBarChartAttributes.h
        BrainBrowserWindowToolBarChartAxes.h
        BrainBrowserWindowToolBarChartTwoAttributes.h
        BrainBrowserWindowToolBarChartTwoAxes.h
        BrainBrowserWindowToolBarChartTwoOrientation.h
        BrainBrowserWindowToolBarChartTwoTitle.h
        BrainBrowserWindowToolBarChartTwoType.h
        BrainBrowserWindowToolBarChartType.h
        BrainBrowserWindowToolBarClipping.h
        BrainBrowserWindowToolBarComponent.h
        BrainBrowserWindowToolBarSlicePlane.h
        BrainBrowserWindowToolBarSliceSelection.h
        BrainBrowserWindowToolBarSurfaceMontage.h
        BrainBrowserWindowToolBarTab.h
        BrainBrowserWindowToolBarTabPopUpMenu.h
        BrainBrowserWindowToolBarVolumeMontage.h
        BrainOpenGLWidget.h
        BugReportDialog.h
        CaretColorEnumComboBox.h
        CaretColorEnumMenu.h
        CaretDataFileSelectionComboBox.h
        CaretFileDialog.h
        CaretFileDialogExtendable.h
        CaretFileRemoteDialog.h
        CaretMappableDataFileAndMapSelector.h
        CaretMappableDataFileAndMapSelectorObject.h
        ChartHistoryViewController.h
        ChartLinesSelectionViewController.h
        ChartMatrixParcelSelectionViewController.h
        ChartMatrixSeriesSelectionViewController.h
        ChartTwoOverlaySetViewController.h
        ChartTwoOverlayViewController.h
        ChartSelectionViewController.h
        ChartToolBoxViewController.h
        CiftiConnectivityMatrixViewController.h
        CiftiParcelSelectionComboBox.h
        ClippingPlanesDialog.h
        ColorEditorWidget.h
	CopyPaletteColorMappingToFilesDialog.h
        CustomViewDialog.h
        DataFileContentCopyMoveDialog.h
        DisplayGroupAndTabItemViewController.h
        DisplayGroupEnumComboBox.h
        EnumComboBoxTemplate.h
        FiberOrientationSelectionViewController.h
        FiberSamplesOpenGLWidget.h
        FociProjectionDialog.h
        FociPropertiesEditorDialog.h
        FociSelectionViewController.h
        GapsAndMarginsDialog.h
        GiftiLabelTableEditor.h
        GiftiLabelTableSelectionComboBox.h
        GroupAndNameHierarchyViewController.h
        GuiManager.h
        HelpViewerDialog.h
        HyperLinkTextBrowser.h
        IdentifyBrainordinateDialog.h
        ImageCaptureDialog.h
        ImageFileConvertToVolumeFileDialog.h
        ImageSelectionViewController.h
        InformationDisplayDialog.h
        InformationDisplayPropertiesDialog.h
        LabelSelectionViewController.h
	LockAspectWarningDialog.h
        MacApplication.h
        MacDockMenu.h
        MapSettingsChartTwoLineHistoryWidget.h
	MapSettingsColorBarPaletteOptionsWidget.h
        MapSettingsColorBarWidget.h
        MapSettingsFiberTrajectoryWidget.h
        MapSettingsLabelsWidget.h
        MapSettingsLayerWidget.h
        MapSettingsPaletteColorMappingWidget.h
        MapSettingsParcelsWidget.h
        MapYokingGroupComboBox.h
        MetaDataEditorDialog.h
        MetaDataEditorWidget.h
        MovieDialog.h
	OffScreenOpenGLRenderer.h
        OverlaySetViewController.h
        OverlaySettingsEditorDialog.h
        OverlayViewController.h
        PaletteColorMappingEditorDialog.h
        PlotMagnifier.h
        PlotPanner.h
        PreferencesDialog.h
        ProgressReportingDialog.h
        ProgressReportingFromEvent.h
        ProgressReportingWithSlots.h
        RegionOfInterestCreateFromBorderDialog.h
        SceneBasePathWidget.h
        SceneCreateReplaceDialog.h
        SceneDialog.h
        ScenePreviewDialog.h
        SceneShowOptionsDialog.h
        SpecFileManagementDialog.h
        SplashScreen.h
        StructureEnumComboBox.h
        StructureSurfaceSelectionControl.h
        SurfacePropertiesEditorDialog.h
        SurfaceSelectionViewController.h
	ThresholdingSetMapsDialog.h
        TileTabsConfigurationDialog.h
        UserInputModeAnnotationsContextMenu.h
        UserInputModeAnnotationsWidget.h
        UserInputModeBordersWidget.h
        UserInputModeFociWidget.h
        UserInputModeImageWidget.h
        UserInputModeViewContextMenu.h
        UserInputModeVolumeEditWidget.h
        UserInputTileTabsContextMenu.h
        UsernamePasswordWidget.h
        VolumeFileCreateDialog.h
        VolumeSurfaceOutlineColorOrTabViewController.h
        VolumeSurfaceOutlineSetViewController.h
        VolumeSurfaceOutlineViewController.h
        WuQCollapsibleWidget.h
        WuQDataEntryDialog.h
        WuQDialog.h
        WuQDialogModal.h
        WuQDialogNonModal.h
        WuQDoubleSlider.h
        WuQDoubleSpinBox.h
        WuQEventBlockingFilter.h
        WuQGridLayoutGroup.h
        WuQGroupBoxExclusiveWidget.h
        WuQImageLabel.h
        WuQListWidget.h
        WuQMessageBox.h
        WuQwtPlot.h
        WuQSpecialIncrementDoubleSpinBox.h
        WuQSpinBoxGroup.h
        WuQSpinBoxOddValue.h
        WuQTabWidget.h
	WuQTabWidgetWithSizeHint.h
	WuQTextEditorDialog.h
        WuQTimedMessageDisplay.h
        WuQTreeWidget.h
        WuQTrueFalseComboBox.h
        #WuQWebView.h
        WuQWidget.h
        WuQWidgetObjectGroup.h
        ZipSceneFileDialog.h
    )

    IF(Qt5_FOUND)
        QT5_WRAP_CPP(MOC_SOURCE_FILES ${MOC_INPUT_HEADER_FILES})
        QT5_WRAP_UI(FORMS_HEADERS ${FORMS})
    ENDIF()
    IF (QT4_FOUND)
        QT4_WRAP_CPP(MOC_SOURCE_FILES ${MOC_INPUT_HEADER_FILES})
        QT4_WRAP_UI(FORMS_HEADERS ${FORMS})
    ENDIF ()
ENDIF()

#
# Header files
#
SET(SOURCE_FILES
AboutWorkbenchDialog.h
AnnotationChangeCoordinateDialog.h
AnnotationColorWidget.h
AnnotationCoordinateInformation.h
AnnotationCoordinateSelectionWidget.h
AnnotationCoordinateSpaceWidget.h
AnnotationCoordinateWidget.h
AnnotationCreateDialog.h
AnnotationDeleteWidget.h
AnnotationFontWidget.h
AnnotationFormatWidget.h
AnnotationInsertNewWidget.h
AnnotationLineArrowTipsWidget.h
AnnotationMenuArrange.h
AnnotationMenuFileSelection.h
AnnotationPasteDialog.h
AnnotationRedoUndoWidget.h
AnnotationRotationWidget.h
AnnotationSelectionViewController.h
AnnotationTextAlignmentWidget.h
AnnotationTextEditorDialog.h
AnnotationTextEditorWidget.h
AnnotationTextOrientationWidget.h
AnnotationTextSubstitutionViewController.h
AnnotationWidgetParentEnum.h
AnnotationWidthHeightWidget.h
BalsaDatabaseManager.h
BalsaDatabaseUploadSceneFileDialog.h
BalsaStudySelectionDialog.h
BalsaStudyInformation.h
BalsaUserRoles.h
BorderEditingSelectionDialog.h
BorderFileSplitDialog.h
BorderOptimizeDialog.h
BorderOptimizeExecutor.h
BorderPropertiesEditorDialog.h
BorderSelectionViewController.h
BrainBrowserWindow.h
BrainBrowserWindowComboBox.h
BrainBrowserWindowEditMenuItemEnum.h
BrainBrowserWindowOrientedToolBox.h
BrainBrowserWindowToolBar.h
BrainBrowserWindowToolBarChartAttributes.h
BrainBrowserWindowToolBarChartAxes.h
BrainBrowserWindowToolBarChartTwoAttributes.h
BrainBrowserWindowToolBarChartTwoAxes.h
BrainBrowserWindowToolBarChartTwoOrientation.h
BrainBrowserWindowToolBarChartTwoTitle.h
BrainBrowserWindowToolBarChartTwoType.h
BrainBrowserWindowToolBarChartType.h
BrainBrowserWindowToolBarClipping.h
BrainBrowserWindowToolBarComponent.h
BrainBrowserWindowToolBarSlicePlane.h
BrainBrowserWindowToolBarSliceSelection.h
BrainBrowserWindowToolBarSurfaceMontage.h
BrainBrowserWindowToolBarTab.h
BrainBrowserWindowToolBarTabPopUpMenu.h
BrainBrowserWindowToolBarVolumeMontage.h
BrainOpenGLWidget.h
BugReportDialog.h
CaretColorEnumComboBox.h
CaretColorEnumMenu.h
CaretDataFileSelectionComboBox.h
CaretFileDialog.h
CaretFileDialogExtendable.h
CaretFileRemoteDialog.h
CaretMappableDataFileAndMapSelector.h
CaretMappableDataFileAndMapSelectorObject.h
ChartHistoryViewController.h
ChartLinesSelectionViewController.h
ChartMatrixParcelSelectionViewController.h
ChartMatrixSeriesSelectionViewController.h
ChartTwoOverlaySetViewController.h
ChartTwoOverlayViewController.h
ChartSelectionViewController.h
ChartToolBoxViewController.h
CiftiConnectivityMatrixViewController.h
CiftiParcelSelectionComboBox.h
ClippingPlanesDialog.h
ColorEditorWidget.h
CopyPaletteColorMappingToFilesDialog.h
CursorDisplayScoped.h
CursorEnum.h
CursorManager.h
CustomViewDialog.h
DataFileContentCopyMoveDialog.h
DisplayGroupAndTabItemTreeWidgetItem.h
DisplayGroupAndTabItemViewController.h
DisplayGroupEnumComboBox.h
EnumComboBoxTemplate.h
EventAnnotationCreateNewType.h
EventAnnotationGetDrawnInWindow.h
EventBrowserWindowDrawingContent.h
EventBrowserWindowCreateTabs.h
EventBrowserWindowGraphicsRedrawn.h
EventBrowserWindowNew.h
EventBrowserWindowTileTabOperation.h
EventGetOrSetUserInputModeProcessor.h
EventGraphicsUpdateAllWindows.h
EventGraphicsUpdateOneWindow.h
EventHelpViewerDisplay.h
EventIdentificationRequest.h
EventImageCapture.h
EventMacDockMenuUpdate.h
EventOperatingSystemRequestOpenDataFile.h
EventOverlaySettingsEditorDialogRequest.h
EventPaletteColorMappingEditorDialogRequest.h
EventShowDataFileReadWarningsDialog.h
EventUpdateInformationWindows.h
EventUpdateVolumeEditingToolBar.h
EventUpdateYokedWindows.h
EventUserInterfaceUpdate.h
FiberOrientationSelectionViewController.h
FiberSamplesOpenGLWidget.h
FociProjectionDialog.h
FociPropertiesEditorDialog.h
FociSelectionViewController.h
GapsAndMarginsDialog.h
GiftiLabelTableEditor.h
GiftiLabelTableSelectionComboBox.h
GroupAndNameHierarchyTreeWidgetItem.h
GroupAndNameHierarchyViewController.h
GuiManager.h
HelpViewerDialog.h
HyperLinkTextBrowser.h
IdentifyBrainordinateDialog.h
ImageCaptureDialog.h
ImageFileConvertToVolumeFileDialog.h
ImageSelectionViewController.h
InformationDisplayDialog.h
InformationDisplayPropertiesDialog.h
KeyEvent.h
LabelSelectionViewController.h
LockAspectWarningDialog.h
MacApplication.h
MacDockMenu.h
MapSettingsChartTwoLineHistoryWidget.h
MapSettingsColorBarPaletteOptionsWidget.h
MapSettingsColorBarWidget.h
MapSettingsFiberTrajectoryWidget.h
MapSettingsLabelsWidget.h
MapSettingsLayerWidget.h
MapSettingsPaletteColorMappingWidget.h
MapSettingsParcelsWidget.h
MapYokingGroupComboBox.h
MetaDataEditorDialog.h
MetaDataEditorWidget.h
MouseEvent.h

=== src/Operations/CMakeLists.txt ===
#
# Name of project
#
PROJECT (Operations)

#
# Add QT for includes
#
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    include_directories(${Qt5Gui_INCLUDE_DIRS})
endif()
IF (QT4_FOUND)
    SET(QT_DONT_USE_QTGUI)
    INCLUDE(${QT_USE_FILE})
ENDIF ()

#
# Create the helper library
#
ADD_LIBRARY(Operations
OperationAddToSpecFile.h
OperationBackendAverageDenseROI.h
OperationBackendAverageROICorrelation.h
OperationBorderExportColorTable.h
OperationBorderFileExportToCaret5.h
OperationBorderLength.h
OperationBorderMerge.h
OperationCiftiChangeMapping.h
OperationCiftiChangeTimestep.h
OperationCiftiConvert.h
OperationCiftiConvertToScalar.h
OperationCiftiCopyMapping.h
OperationCiftiCreateDenseFromTemplate.h
OperationCiftiCreateParcellatedFromTemplate.h
OperationCiftiCreateScalarSeries.h
OperationCiftiEstimateFWHM.h
OperationCiftiExportDenseMapping.h
OperationCiftiLabelExportTable.h
OperationCiftiLabelImport.h
OperationCiftiMath.h
OperationCiftiMerge.h
OperationCiftiPalette.h
OperationCiftiResampleDconnMemory.h
OperationCiftiROIAverage.h
OperationCiftiSeparateAll.h
OperationCiftiStats.h
OperationCiftiWeightedStats.h
OperationConvertAffine.h
OperationConvertFiberOrientations.h
OperationConvertMatrix4ToMatrix2.h
OperationConvertMatrix4ToWorkbenchSparse.h
OperationConvertWarpfield.h
OperationEstimateFiberBinghams.h
OperationException.h
OperationFileConvert.h
OperationFileInformation.h
OperationFociGetProjectionVertex.h
OperationFociListCoords.h
OperationGiftiConvert.h
OperationLabelExportTable.h
OperationLabelMask.h
OperationLabelMerge.h
OperationMetadataRemoveProvenance.h
OperationMetadataStringReplace.h
OperationMetricConvert.h
OperationMetricLabelImport.h
OperationMetricMask.h
OperationMetricMath.h
OperationMetricMerge.h
OperationMetricPalette.h
OperationMetricStats.h
OperationMetricVertexSum.h
OperationMetricWeightedStats.h
OperationNiftiInformation.h
OperationProbtrackXDotConvert.h
OperationSceneFileMerge.h
OperationSceneFileRelocate.h
OperationSetMapName.h
OperationSetMapNames.h
OperationSetStructure.h
OperationShowScene.h
OperationSpecFileMerge.h
OperationSpecFileRelocate.h
OperationSurfaceClosestVertex.h
OperationSurfaceCoordinatesToMetric.h
OperationSurfaceCutResample.h
OperationSurfaceFlipNormals.h
OperationSurfaceGeodesicDistance.h
OperationSurfaceGeodesicDistanceAllToAll.h
OperationSurfaceGeodesicROIs.h
OperationSurfaceInformation.h
OperationSurfaceNormals.h
OperationSurfaceSetCoordinates.h
OperationSurfaceVertexAreas.h
OperationVolumeCapturePlane.h
OperationVolumeCopyExtensions.h
OperationVolumeCreate.h
OperationVolumeLabelExportTable.h
OperationVolumeLabelImport.h
OperationVolumeMath.h
OperationVolumeMerge.h
OperationVolumePalette.h
OperationVolumeReorient.h
OperationVolumeSetSpace.h
OperationVolumeStats.h
OperationVolumeWeightedStats.h
OperationWbsparseMergeDense.h
OperationZipSceneFile.h
OperationZipSpecFile.h

OperationAddToSpecFile.cxx
OperationBackendAverageDenseROI.cxx
OperationBackendAverageROICorrelation.cxx
OperationBorderExportColorTable.cxx
OperationBorderFileExportToCaret5.cxx
OperationBorderLength.cxx
OperationBorderMerge.cxx
OperationCiftiChangeMapping.cxx
OperationCiftiChangeTimestep.cxx
OperationCiftiConvert.cxx
OperationCiftiConvertToScalar.cxx
OperationCiftiCopyMapping.cxx
OperationCiftiCreateDenseFromTemplate.cxx
OperationCiftiCreateParcellatedFromTemplate.cxx
OperationCiftiCreateScalarSeries.cxx
OperationCiftiEstimateFWHM.cxx
OperationCiftiExportDenseMapping.cxx
OperationCiftiLabelExportTable.cxx
OperationCiftiLabelImport.cxx
OperationCiftiMath.cxx
OperationCiftiMerge.cxx
OperationCiftiPalette.cxx
OperationCiftiResampleDconnMemory.cxx
OperationCiftiROIAverage.cxx
OperationCiftiSeparateAll.cxx
OperationCiftiStats.cxx
OperationCiftiWeightedStats.cxx
OperationConvertAffine.cxx
OperationConvertFiberOrientations.cxx
OperationConvertMatrix4ToMatrix2.cxx
OperationConvertMatrix4ToWorkbenchSparse.cxx
OperationConvertWarpfield.cxx
OperationException.cxx
OperationEstimateFiberBinghams.cxx
OperationFileConvert.cxx
OperationFileInformation.cxx
OperationFociGetProjectionVertex.cxx
OperationFociListCoords.cxx
OperationGiftiConvert.cxx
OperationLabelExportTable.cxx
OperationLabelMask.cxx
OperationLabelMerge.cxx
OperationMetadataRemoveProvenance.cxx
OperationMetadataStringReplace.cxx
OperationMetricConvert.cxx
OperationMetricLabelImport.cxx
OperationMetricMask.cxx
OperationMetricMath.cxx
OperationMetricMerge.cxx
OperationMetricPalette.cxx
OperationMetricStats.cxx
OperationMetricVertexSum.cxx
OperationMetricWeightedStats.cxx
OperationNiftiInformation.cxx
OperationProbtrackXDotConvert.cxx
OperationSceneFileMerge.cxx
OperationSceneFileRelocate.cxx
OperationSetMapName.cxx
OperationSetMapNames.cxx
OperationSetStructure.cxx
OperationShowScene.cxx
OperationSpecFileMerge.cxx
OperationSpecFileRelocate.cxx
OperationSurfaceClosestVertex.cxx
OperationSurfaceCoordinatesToMetric.cxx
OperationSurfaceCutResample.cxx
OperationSurfaceFlipNormals.cxx
OperationSurfaceGeodesicDistance.cxx
OperationSurfaceGeodesicDistanceAllToAll.cxx
OperationSurfaceGeodesicROIs.cxx
OperationSurfaceInformation.cxx
OperationSurfaceNormals.cxx
OperationSurfaceSetCoordinates.cxx
OperationSurfaceVertexAreas.cxx
OperationVolumeCapturePlane.cxx
OperationVolumeCopyExtensions.cxx
OperationVolumeCreate.cxx
OperationVolumeLabelExportTable.cxx
OperationVolumeLabelImport.cxx
OperationVolumeMath.cxx
OperationVolumeMerge.cxx
OperationVolumePalette.cxx
OperationVolumeReorient.cxx
OperationVolumeSetSpace.cxx
OperationVolumeStats.cxx
OperationVolumeWeightedStats.cxx
OperationWbsparseMergeDense.cxx
OperationZipSceneFile.cxx
OperationZipSpecFile.cxx
)

TARGET_LINK_LIBRARIES(Operations ${CARET_QT5_LINK})

#
# Find Headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Algorithms
${CMAKE_SOURCE_DIR}/Annotations
${CMAKE_SOURCE_DIR}/Operations
${CMAKE_SOURCE_DIR}/OperationsBase
${CMAKE_SOURCE_DIR}/Brain
${CMAKE_SOURCE_DIR}/Charting
${CMAKE_SOURCE_DIR}/Palette
${CMAKE_SOURCE_DIR}/FilesBase
${CMAKE_SOURCE_DIR}/Files
${CMAKE_SOURCE_DIR}/Gifti
${CMAKE_SOURCE_DIR}/Graphics
${CMAKE_SOURCE_DIR}/Cifti
${CMAKE_SOURCE_DIR}/Nifti
${QUAZIP_INCLUDE_DIRS}
${CMAKE_SOURCE_DIR}/Scenes
${CMAKE_SOURCE_DIR}/Xml
${CMAKE_SOURCE_DIR}/Common
)

#
# Mesa Library used by show scene command
#
IF (OSMESA_FOUND)
    ADD_DEFINITIONS(${OSMESA_DEFINITION})
    INCLUDE_DIRECTORIES(${OSMESA_INCLUDE_DIRECTORY})
ENDIF (OSMESA_FOUND)

=== src/Scenes/CMakeLists.txt ===
#
# Name of Project
#
PROJECT (Scenes)

#
# SceneObject is derived from CaretObject.  When a scene is created many 
# instances of SceneObject may be created via its subclasses. 
# When compiled with debugging on, CaretObject maintains a call stack
# and new/delete is tracked for all CaretObjects.  As a result, the many 
# instances of SceneObject will cause reading of scenes to be slow and
# memory usage to become excessive.  So, do not derive SceneObject from
# CaretObject unless CARET_SCENE_DEBUG is defined.
#
#ADD_DEFINITIONS(-DCARET_SCENE_DEBUG)

#
# QT include files
#
SET(CARET_QT_LINK_MODULES "")
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    #include_directories(${Qt5Network_INCLUDE_DIRS})
    include_directories(${Qt5Xml_INCLUDE_DIRS})
    SET(CARET_QT_LINK_MODULES "Qt5::Core")
endif()
IF (QT4_FOUND)
    SET(QT_DONT_USE_QTGUI TRUE)
    INCLUDE(${QT_USE_FILE})
ENDIF ()

#
# Create a Library
#
ADD_LIBRARY(Scenes
BackgroundAndForegroundColorsSceneHelper.h
DisplayGroupAndTabItemHelper.h
Scene.h
SceneAttributes.h
SceneBoolean.h
SceneBooleanArray.h
SceneClass.h
SceneClassArray.h
SceneClassAssistant.h
SceneEnumeratedTypeArray.h
SceneEnumeratedType.h
SceneFileBasePathTypeEnum.h
SceneFloat.h
SceneFloatArray.h
SceneInfo.h
SceneInfoSaxReader.h
SceneInteger.h
SceneIntegerArray.h
SceneObject.h
SceneObjectArray.h
SceneObjectDataTypeEnum.h
SceneObjectMapIntegerKey.h
ScenePathName.h
ScenePathNameArray.h
ScenePrimitive.h
ScenePrimitiveArray.h
SceneSaxReader.h
SceneString.h
SceneStringArray.h
SceneTypeEnum.h
SceneUnsignedByte.h
SceneUnsignedByteArray.h
SceneWriterInterface.h
SceneWriterXml.h
SceneXmlElements.h
SceneableInterface.h

BackgroundAndForegroundColorsSceneHelper.cxx
DisplayGroupAndTabItemHelper.cxx
Scene.cxx
SceneAttributes.cxx
SceneBoolean.cxx
SceneBooleanArray.cxx
SceneClass.cxx
SceneClassArray.cxx
SceneClassAssistant.cxx
SceneEnumeratedTypeArray.cxx
SceneEnumeratedType.cxx
SceneFileBasePathTypeEnum.cxx
SceneFloat.cxx
SceneFloatArray.cxx
SceneInfo.cxx
SceneInfoSaxReader.cxx
SceneInteger.cxx
SceneIntegerArray.cxx
SceneObject.cxx
SceneObjectArray.cxx
SceneObjectDataTypeEnum.cxx
SceneObjectMapIntegerKey.cxx
ScenePathName.cxx
ScenePathNameArray.cxx
ScenePrimitive.cxx
ScenePrimitiveArray.cxx
SceneSaxReader.cxx
SceneString.cxx
SceneStringArray.cxx
SceneTypeEnum.cxx
SceneUnsignedByte.cxx
SceneUnsignedByteArray.cxx
SceneWriterXml.cxx
)

TARGET_LINK_LIBRARIES(Scenes ${CARET_QT5_LINK})

#
# Find headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Common
${CMAKE_SOURCE_DIR}/Xml
)

=== src/kloewe/dot/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.7.8)

project(dot)

if(CMAKE_VERSION VERSION_LESS "2.8.12")
    function(add_compile_options)
        add_definitions(${ARGN})
    endfunction(add_compile_options)
endif()

add_compile_options(-std=c99 -Wall -Wextra -Wno-unused-parameter -Wconversion -Wshadow -pedantic)

SET(DOT_USEFMA 0)
SET(DOT_USEAVX512 0)

if (CMAKE_COMPILER_IS_GNUCC)
    execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
    string(FIND ${GCC_VERSION} "." GCC_VERSION_HAS_DOT)
    if (${GCC_VERSION_HAS_DOT} EQUAL -1)
        execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpfullversion OUTPUT_VARIABLE GCC_VERSION)
    endif()
    if (GCC_VERSION VERSION_GREATER 4.7 OR GCC_VERSION VERSION_EQUAL 4.7)
        message(STATUS "GCC version >= 4.7")
        SET(DOT_USEFMA 1)
    endif()
    if (GCC_VERSION VERSION_GREATER 7.1 OR GCC_VERSION VERSION_EQUAL 7.1)
        message(STATUS "GCC version >= 7.1")
        add_compile_options(-Wimplicit-fallthrough=0)
        SET(DOT_USEAVX512 1)
    endif()
endif()

add_library(dot src/dot.c)
add_library(dot_naive src/dot_naive.c)
add_library(dot_sse2 src/dot_sse2.c)
add_library(dot_avx src/dot_avx.c)
if(DOT_USEFMA AND DOT_USEAVX512)
    add_library(dot_avxfma src/dot_avx.c)
    add_library(dot_avx512 src/dot_avx512.c)
    add_library(dot_avx512fma src/dot_avx512.c)
    target_link_libraries(dot dot_naive dot_sse2 dot_avx dot_avxfma dot_avx512 dot_avx512fma cpuinfo ${CARET_QT5_LINK})
elseif(DOT_USEFMA)
    add_library(dot_avxfma src/dot_avx.c)
    target_link_libraries(dot dot_naive dot_sse2 dot_avx dot_avxfma cpuinfo ${CARET_QT5_LINK})
elseif(DOT_USEAVX512)
    add_library(dot_avx512 src/dot_avx512.c)
    target_link_libraries(dot dot_naive dot_sse2 dot_avx dot_avx512 cpuinfo ${CARET_QT5_LINK})
else()
    target_link_libraries(dot dot_naive dot_sse2 dot_avx cpuinfo ${CARET_QT5_LINK})
endif()

if(CMAKE_VERSION VERSION_LESS "2.8.12")
    if(DOT_USEFMA AND DOT_USEAVX512)
        set_target_properties(dot_avxfma PROPERTIES COMPILE_FLAGS "-mfma -mavx -funroll-loops")
        set_target_properties(dot_avx512 PROPERTIES COMPILE_FLAGS "-mavx512f -funroll-loops")
        set_target_properties(dot_avx512fma PROPERTIES COMPILE_FLAGS "-mavx512f -mfma -funroll-loops")
    elseif(DOT_USEFMA)
        set_target_properties(dot_avxfma PROPERTIES COMPILE_FLAGS "-mfma -mavx -funroll-loops")
        set_target_properties(dot PROPERTIES COMPILE_FLAGS "-DDOT_NOAVX512")
    elseif(DOT_USEAVX512)
        set_target_properties(dot_avx512 PROPERTIES COMPILE_FLAGS "-mavx512f -funroll-loops")
        set_target_properties(dot PROPERTIES COMPILE_FLAGS "-DDOT_NOFMA")
    else()
        set_target_properties(dot PROPERTIES COMPILE_FLAGS "-DDOT_NOFMA -DDOT_NOAVX512")
    endif()
    set_target_properties(dot_avx PROPERTIES COMPILE_FLAGS "-mavx -funroll-loops")
    set_target_properties(dot_sse2 PROPERTIES COMPILE_FLAGS "-msse2")
    include_directories(../cpuinfo/src)
else()
    if(DOT_USEFMA AND DOT_USEAVX512)
        target_compile_options(dot_avxfma PRIVATE -mfma -mavx -funroll-loops)
        target_compile_options(dot_avx512 PRIVATE -mavx512f -funroll-loops)
        target_compile_options(dot_avx512fma PRIVATE -mavx512f -mfma -funroll-loops)
    elseif(DOT_USEFMA)
        target_compile_options(dot_avxfma PRIVATE -mfma -mavx -funroll-loops)
        target_compile_definitions(dot PRIVATE "DOT_NOAVX512")
    elseif(DOT_USEAVX512)
        target_compile_options(dot_avx512 PRIVATE -mavx512f -funroll-loops)
        target_compile_definitions(dot PRIVATE "DOT_NOFMA")
    else()
        target_compile_definitions(dot PRIVATE "DOT_NOFMA" "DOT_NOAVX512")
    endif()
    target_compile_options(dot_avx PRIVATE -mavx -funroll-loops)
    target_compile_options(dot_sse2 PRIVATE -msse2)
    target_include_directories(dot PRIVATE ../cpuinfo/src)
endif()

=== debian/changelog ===
connectome-workbench (1.3.2.1+rb2-1+eagle) unstable; urgency=medium

  * update

 -- NeuroDebian Team <team@neuro.debian.net>  Wed, 27 Jan 2021 15:58:00 +0800

=== debian/control ===
Source: connectome-workbench
Section: science
Priority: extra
Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 9),
               help2man, cmake,
               libosmesa6-dev,
               qtbase5-dev,
               libssl-dev, zlib1g-dev,
               libqt5opengl5-dev,
               libglib2.0-dev,
               xauth, xvfb,
               libftgl-dev,
Standards-Version: 3.9.8
Homepage: http://www.nitrc.org/projects/workbench/
Vcs-Git: git://github.com/neurodebian/workbench -b debian
Vcs-Browser: http://github.com/neurodebian/workbench

Package: connectome-workbench
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: caret
Suggests: ffmpeg
Description: brain visualization, analysis and discovery tool
 Connectome Workbench is a brain visualization, analysis and discovery
 tool for fMRI and dMRI brain imaging data, including functional and
 structural connectivity data generated by the Human Connectome
 Project.
 .
 Package includes wb_command, a command-line program for performing a
 variety of analytical tasks for volume, surface, and CIFTI
 grayordinates data.

Package: connectome-workbench-dbg
Architecture: any
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
         connectome-workbench (= ${binary:Version})
Description: brain visualization, analysis and discovery tool -- debug symbols
 Connectome Workbench is a brain visualization, analysis and discovery
 tool for fMRI and dMRI brain imaging data, including functional and
 structural connectivity data generated by the Human Connectome
 Project.
 .
 Package includes wb_command, a command-line program for performing a
 variety of analytical tasks for volume, surface, and CIFTI
 grayordinates data.
 .
 This package contains debug symbols for the binaries.
